unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, 
  StdCtrls, ExtCtrls, ComCtrls, mmsystem, Menus;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    PopupMenu1: TPopupMenu;
    N11: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N61: TMenuItem;
    N71: TMenuItem;
    N81: TMenuItem;
    N91: TMenuItem;
    N101: TMenuItem;
    N111: TMenuItem;
    N121: TMenuItem;
    N131: TMenuItem;
    N141: TMenuItem;
    N151: TMenuItem;
    Off1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
  private
    procedure Clicks(Sender:TObject;Button:TMouseButton;Shift:TShiftState;X,Y:Integer);
  end;

var
  Form1: TForm1;
  panel:array[1..15] of tpanel;
  tp,tem:array [1..4,1..4] of integer;
  p1,p2:byte;
  mdata:array [1..17] of pointer;
  s:byte;
  a:array [1..7] of integer=(1,3,6,8,9,11,14);
  zvuki:boolean;

implementation

{$R *.DFM}
{$R MyWave.res}

function pos(x:byte):integer;
 var i,j,k,g:integer;
begin
 k:=0;
 g:=0;
 for i:=1 to 4 do for j:=1 to 4 do
 if tem[i,j]=x then begin
  k:=i;
  g:=j;
  break
 end;
 result:=k*256+g;
end;

procedure dvig(n,m,k:integer);
 var i,j,l:integer;
begin
 i:=n-p1;
 j:=m-p2;
 if (abs(i)+abs(j))<>1 then exit;
 if zvuki then s:=k;
 if s<>16 then PlaySound(mdata[s],0,SND_MEMORY or snd_async);
 for l:=1 to 56 do begin
  panel[k].left:=panel[k].left-j;
  panel[k].top:=panel[k].top-i;
  panel[k].repaint;
 end;
 tp[n,m]:=0;
 tp[p1,p2]:=k;
 p1:=n;
 p2:=m;
 for i:=1 to 4 do for j:=1 to 4 do begin if (i=p1) and (j=p2) then continue;
 if tp[i,j]<>(i-1)*4+j then exit end;
 sleep(10);
 PlaySound(mdata[16],0,SND_MEMORY);
end;

procedure Tform1.Clicks(Sender:TObject;Button:TMouseButton;Shift:TShiftState;X,Y:Integer);
 var i,j,k:integer;
begin
 if ssleft in shift then begin
  for k:=1 to 16 do if sender=panel[k] then break;
  for i:=1 to 4 do for j:=1 to 4 do if tp[i,j]=k then begin
   dvig(i,j,k);
   exit
  end
 end
end;

function prov:boolean;//   ,      ( )
 var i,j,n,m:integer;
begin
 for i:=1 to 4 do for j:=1 to 4 do begin
  tem[i,j]:=tp[i,j];   //    ()  
  if tp[i,j]=0 then begin  //     
   p1:=i;
   p2:=j
  end
 end;
 result:=true;  //  ,   
 for i:=1 to 7 do if a[i]=(p1-1)*4+p2 then result:=not result;//                 
 tem[p1,p2]:=tem[4,4];//          ,      
 tem[4,4]:=0;         //    
 for i:=1 to 4 do for j:=1 to 4 do begin //     
  if (tem[i,j]<>((i-1)*4+j)) and (tem[i,j]>0) then begin //           , 
   m:=pos((i-1)*4+j);   //  ,       
   n:=m div 256;
   m:=m-n*256;
   tem[n,m]:=tem[i,j];  //     
   tem[i,j]:=(i-1)*4+j;
   result:=not result    //         
  end;
 end;
end;

procedure createpole;
 var i,j,k:integer;
begin
 randomize;
 repeat
  for i:=1 to 4 do for j:=1 to 4 do tp[i,j]:=0; k:=1;
   repeat begin
    i:=random(4)+1;
    j:=random(4)+1;
    if tp[i,j]=0 then begin tp[i,j]:=k; inc(k) end;
   end until k=16;
 until prov;
 for i:=1 to 4 do for j:=1 to 4 do if tp[i,j]=0 then begin p1:=i; p2:=j; break end;
 for i:=1 to 4 do for j:=1 to 4 do begin
  if (i=p1) and (j=p2) then continue;
  panel[tp[i,j]].top:=(i-1)*56+3;
  panel[tp[i,j]].left:=(j-1)*56+3;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
 var i,j,k:integer;
begin
 zvuki:=true;
 k:=1;
 for j:=1 to 4 do begin
  for i:=1 to 4 do begin
   if (j=4) and (i=4) then continue;
   panel[k]:=tpanel.create(self);
   with panel[k] do begin
    parent:=TWinControl(panel1);
    left:=(i-1)*56+3;
    top:=(j-1)*56+3;
    height:=55;
    width:=55;
    color:=$00FEEA8D;
    bevelinner:=bvLowered;
    bevelouter:=bvspace;
    font.Name:='PromtImperial';
    font.Size:=25;
    font.Style:=font.Style+[fsbold];
    font.Charset:=SHIFTJIS_CHARSET;
    caption:=inttostr(k);
    onmousedown:=clicks;
    tp[j,i]:=k;
    inc(k);
   end;
  end;
 end;
 tp[4,4]:=0;
 p1:=4;p2:=4;
 for i:=1 to 17 do
 mData[i]:=LockResource(LoadResource(hInstance,FindResource(hInstance,pchar('MyWave'+inttostr(i)),RT_RCDATA)));
 createpole;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 PlaySound(mdata[17],0,SND_MEMORY or snd_async);
 createpole;
 sleep(10);
end;

procedure TForm1.N11Click(Sender: TObject);
 var i:integer;
begin
 for i:=1 to 16 do if popupmenu1.Items.items[i-1]=sender then break;
 popupmenu1.Items.items[i-1].checked:=not popupmenu1.Items.items[i-1].checked;
 if popupmenu1.Items.items[i-1].checked=true then begin zvuki:=false; s:=i; end else zvuki:=true;
end;

end.
